3 ### Common per-shell configuration.
5 ###--------------------------------------------------------------------------
8 __mdw_programp () { type >/dev/null 2>&1 "$1"; }
10 __mdw_source_if_exists () {
13 if [ -r "$i" ]; then . "$i"; fi
17 ###--------------------------------------------------------------------------
24 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
29 *) eval "$hk=\${$hk:+\$$hk }\$fn" ;;
34 local hk=$1 fn=$2 t l r
37 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
42 l=${t%% $fn*} r=${t##*$fn }
44 eval "$hk=\$l\${l:+ }\$r"
49 __mdw_setrc () { return $1; }
52 local hk=$1 saverc=$? t i; shift
55 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
58 for i in $t; do __mdw_setrc $saverc; "$i" "$@"; done
61 ###--------------------------------------------------------------------------
64 __mdw_host=$(hostname)
66 __mdw_hqual=$__mdw_hqual${SCHROOT_CHROOT_NAME+/$SCHROOT_CHROOT_NAME}
67 __mdw_hqual=$__mdw_hqual${CROSS_BUILDENV+/$CROSS_BUILDENV}
68 __mdw_set_prompt_hacks () { host=$__mdw_host; dir=""; }
70 __mdw_system=$(uname -s)
71 : ${USER-${LOGNAME-$(id -un)}}
82 *" 544 "*) __mdw_rootp=t __mdw_user="$__mdw_user%admin" ;;
92 __mdw_set_prompt_pieces () {
94 ## Fancy highlighting in some terminals.
95 local bold unbold nl more host dir
96 local gitcolour extracolour rccolour uncolour
97 bold="" unbold="" nl="" more=""
98 gitcolour="" extracolour="" rccolour="" uncolour=""
99 __mdw_set_prompt_hacks
101 ## Choose the right delimiters. Highlight root prompts specially;
102 ## highlight when I'm running as some other user. Highlight when this
103 ## isn't the outermost shell on the terminal.
104 local left right u tty
107 left=$(echo « | iconv -f UTF-8 -t //translit)
108 right=$(echo » | iconv -f UTF-8 -t //translit)
112 mdw | mwooding | nemo) u="" left="[" right="]" ;;
113 *) u="$__mdw_user@" left="{" right="}" ;;
117 "$tty") left="<" right=">" ;;
118 *) __mdw_tty=$tty; export __mdw_tty ;;
123 ## If this session is insecure then highlight that.
126 case ${SSH_CLIENT-nil},${SCHROOT_CHROOT_NAME-nil},$__mdw_sechost in
127 nil,nil,"$h") sec_l="" sec_r="" ;;
128 nil,nil,*) sec_l="(" sec_r=")" ;;
132 ## If this is an schroot environment or some other interesting augmented
133 ## environment then point this out.
135 ## Put together the main pieces.
136 __mdw_prompt_left="$nl$bold$left$sec_l$u$host$__mdw_hqual$sec_r$dir"
137 __mdw_prompt_git_left="$unbold$gitcolour"
138 __mdw_prompt_git_right="$uncolour$bold"
139 __mdw_prompt_rc_left="$unbold$rccolour"
140 __mdw_prompt_rc_right="$uncolour$bold"
141 __mdw_prompt_extra_left="$unbold$extracolour"
142 __mdw_prompt_extra_right="$uncolour$bold"
143 __mdw_prompt_right="$right$unbold"
144 __mdw_prompt_more=" $more$bold>$unbold "
147 __mdw_set_prompt () {
148 case "${TERM-dumb}:${INSIDE_EMACS+$INSIDE_EMACS}" in
150 case $(id -u) in 0) PS1='# ' ;; *) PS1='$ ' ;; esac
156 if type __git_ps1 >/dev/null 2>&1; then
157 git="$__mdw_prompt_git_left$(__git_ps1)$__mdw_prompt_git_right"
161 case $__mdw_last_rc in
163 *) rc="$__mdw_prompt_rc_left rc=$__mdw_last_rc$__mdw_prompt_rc_right" ;;
165 case $__mdw_prompt_extra in
166 ?*) extra="$__mdw_prompt_extra_left [$__mdw_prompt_extra]$__mdw_prompt_extra_right" ;;
169 PS1="$__mdw_prompt_left$git$extra$rc$__mdw_prompt_right"
170 PS2="$PS1$__mdw_prompt_more"
176 __mdw_xterm_settitle () {
178 "
\e]0;%s@%s:%s – %s
\e\\" \
179 "$__mdw_user" "$__mdw_host$__mdw_hqual" "$PWD" \
182 __mdw_xterm_precmd () { __mdw_xterm_settitle "$__mdw_shell"; }
183 __mdw_xterm_preexec () { __mdw_xterm_settitle "$1"; }
185 __mdw_screen_settitle () {
190 __mdw_screen_precmd () { __mdw_screen_settitle "$__mdw_shell"; }
191 __mdw_screen_preexec () { __mdw_screen_settitle "$1"; }
194 case ${STY+t},${__mdw_precmd_hook+t},${__mdw_preexec_hook+t},${TERM} in
196 __mdw_addhook __mdw_precmd_hook __mdw_xterm_precmd
197 __mdw_addhook __mdw_preexec_hook __mdw_xterm_preexec
200 __mdw_addhook __mdw_precmd_hook __mdw_screen_precmd
201 __mdw_addhook __mdw_preexec_hook __mdw_screen_preexec
204 case ${__mdw_precmd_hook+t} in
205 t) __mdw_addhook __mdw_precmd_hook __mdw_set_prompt ;;
209 ###--------------------------------------------------------------------------
210 ### Some handy aliases.
213 alias which="command -v"
216 case $# in 0) set -- "${SHELL-/bin/sh}" ;; esac
220 alias re="rootly $EDITOR"
221 alias pstree="pstree -hl"
222 alias cdtmp='cd ${TMPDIR-/tmp}'
223 alias pushtmp='pushd ${TMPDIR-/tmp}'
225 alias svn="svnwrap svn"
228 if command -v ionice >/dev/null 2>&1; then
229 __mdw_nice="$__mdw_nice ionice -c3"
231 alias mdw-nice="$__mdw_nice --"
232 alias make="mdw-nice make"
233 alias mvn="mdw-nice mvn"
234 alias cross-run="mdw-nice cross-run"
237 ## Shut up Lisp interpreters.
238 alias clisp="clisp -q -q"
239 if command -v ionice >/dev/null 2>&1; then
240 alias maybe-rlwrap="rlwrap"
242 alias maybe-rlwrap=""
244 alias cmucl="maybe-rlwrap cmucl -quiet"
245 alias ecl="maybe-rlwrap ecl"
246 alias sbcl="maybe-rlwrap sbcl --noinform"
247 alias ccl="maybe-rlwrap ccl"
248 alias ccl32="maybe-rlwrap ccl32"
249 alias ccl64="maybe-rlwrap ccl64"
250 alias abcl="maybe-rlwrap abcl --noinform"
252 ###--------------------------------------------------------------------------
256 if ! [ -t 1 ]; then return 1; fi
257 case $TERM in dumb) return 1 ;; esac
261 ## Arrange for `ls' output to be in colour.
262 unalias ls 2>/dev/null || :
264 if mdw_colour_p; then command ls $LS_OPTIONS ${LS_COLORS+--color=always} "$@"
265 else command ls "$@"; fi
268 ## Arrange for `grep' output to be in colour.
271 if mdw_colour_p; then
272 command $grep ${GREP_COLORS+--color=always} "$@" | mdw-pager
277 alias grep="greplike grep"
278 alias egrep="greplike egrep"
279 alias fgrep="greplike fgrep"
280 alias zgrep="greplike zgrep"
282 ## Arrange for `diff' output to be in colour.
285 if mdw_colour_p; then
287 ${DIFF_COLORS+--color=always} \
288 ${DIFF_COLORS+--palette="$DIFF_COLORS"} \
291 command $diff "$@" | cat
294 alias diff="difflike diff"
296 ###--------------------------------------------------------------------------
299 ## Turn off pagers inside Emacs shell buffers.
300 case "$INSIDE_EMACS" in
301 2[2-9].*,comint | [3-9][0-9].*,comint) export PAGER=cat ;;
304 ###--------------------------------------------------------------------------
305 ### More complicated shell functions.
307 ## xt [@HOST] XTERM-ARGS
309 ## Open a terminal, maybe on a remote host.
313 local remote=${1#@} title
315 if [ $# -gt 0 ]; then
316 title="xterm [$remote] $1"
318 title="xterm [$remote]"
320 (xterm -title "$title" -e ssh $remote "$@" &)
330 ## Tweak core dumps on and off, or show the current status.
333 xon|xy|xyes) ulimit -Sc $(ulimit -Hc) ;;
334 xoff|xn|xno) ulimit -Sc 0 ;;
336 local l=$(ulimit -Sc)
338 0) echo "Core dumps disabled" ;;
339 unlimited) echo "Core dumps enabled" ;;
340 *) echo "Core dump limit is $l blocks" ;;
344 echo >&2 "usage: core [y|n]"
352 ## Set current security world to NAME. With no NAME, print the currently
355 local nfast=${NFAST_HOME-/opt/nfast}
359 echo "${NFAST_KMDATA#$nfast/kmdata-}"
364 elif [ -d "$nfast/kmdata-$1" ]; then
365 kmdata=$nfast/kmdata-$1
367 echo >&2 "world: can't find world $1"
372 0) export NFAST_KMDATA=$kmdata ;;
379 ## path-add [VAR] DIR
381 ## Add DIR to the beginning of PATH-like variable VAR (defaults to PATH) if
382 ## it's not there already.
384 local pathvar export dir val
386 1) pathvar=PATH dir=$1 export="export PATH" ;;
387 2) pathvar=$1 dir=$2 export=: ;;
388 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
399 ## path-remove [VAR] DIR
401 ## Remove DIR from PATH-like variable VAR (defaults to PATH); it's not an
402 ## error if DIR isn't in VAR.
404 local pathvar export dir val
406 1) pathvar=PATH dir=$1 export="export PATH" ;;
407 2) pathvar=$1 dir=$2 export=: ;;
408 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
413 :"$dir":*) val=${val#$dir:} ;;
414 *:"$dir":) val=${val%:$dir} ;;
415 *:"$dir":*) val=${val%%:$dir:*}:${val#*:$dir:} ;;
421 ## pathhack [-f] +HACK|-HACK...
423 ## Each HACK refers to a subdirectory of `~/bin/hacks'. A hack name preceded
424 ## by `+' adds the directory to the PATH; a `-' removes. Adding a hack
425 ## that's already on the PATH doesn't do anything unless `-f' is set, in
426 ## which case it gets moved to the beginning. With no arguments, print the
427 ## currently installed hacks.
429 local p e force arg hack dir
431 if [ $# -eq 0 ]; then
434 case "$e" in "$HOME/bin/hacks/"*) echo ${e#$HOME/bin/hacks/} ;; esac
435 case "$p" in *:*) p=${p#*:} ;; *) break ;; esac
440 while [ $# -gt 0 ]; do
443 -f | --force) force=t; shift; continue ;;
449 dir=$HOME/bin/hacks/$hack
450 if ! [ -d "$dir" ]; then
451 echo "$0: path hack $hack not found"
454 case "$arg,$force,:$PATH:" in
455 -*,*,*:"$dir":*) path_remove p "$dir" ;;
456 +*,t,*:"$dir":*) path_remove p "$dir"; path_add p "$dir" ;;
457 +*,nil,*:"$dir":*) ;;
458 +*,*) path_add p "$dir" ;;
462 if [ $# -eq 0 ]; then PATH=$p; export PATH
463 else PATH=$p "$@"; fi
466 ###--------------------------------------------------------------------------
467 ### Finishing touches.
469 ## Make sure `$HOME/bin' is on the path.
472 ## Set the temporary directory again. (A setuid or setgid program may have
473 ## unhelpfully forgotten this for us.)
476 *) if __mdw_programp tmpdir; then eval $(tmpdir -b); fi ;;
479 ## For `root' use -- some simple molly-guards.
482 alias rm="rm -i" cp="cp -i" mv="mv -i"
487 ## Install wakeup machinery for long-running programs.
488 case ${DISPLAY+t},${WINDOWID+t},${__mdw_precmd_hook+t},${__mdw_preexec_hook+t} in
490 if [ -t 0 ] && __mdw_programp notify-send; then . $HOME/bin/wakey.sh; fi
494 ## Run any local hooks.
495 __mdw_source_if_exists "$HOME/.shell-local"
497 ###----- That's all, folks --------------------------------------------------